// eslint-disable-next-line no-undef
document.addEventListener('DOMContentLoaded', () => {
    // eslint-disable-next-line no-undef
    const addToQuoteButton = document.querySelector('#product-add-to-quote');
    if (addToQuoteButton) {
        addToQuoteButton.addEventListener('click', (event) => {
            event.preventDefault();

            // eslint-disable-next-line no-undef
            const addToCartForm = document.querySelector('[name=sylius_add_to_cart]');
            const redirectUrl = addToQuoteButton.dataset.redirect;

            // eslint-disable-next-line no-undef
            const formData = new FormData(addToCartForm);
            const headers = new Headers({ 'X-Requested-With': 'XMLHttpRequest' })
            const validationElement = document.querySelector('#sylius-cart-validation-error');

            // eslint-disable-next-line no-undef
            fetch(addToQuoteButton.href, { method: 'POST', body: formData, headers: headers })
                .then((response) => {
                    if (String(response.status).match(/^2.*/)) {
                        validationElement.classList.add('d-none');

                        if (redirectUrl !== undefined) {
                            window.location = redirectUrl;
                            return;
                        }

                        return {};
                    }

                    return response.json();
                })
                .then((data) => {
                    if (!data.errors) {
                        return;
                    }

                    validationElement.classList.remove('d-none');
                    const validationMessage = [];

                    Object.entries(data.errors.errors).forEach(([, message]) => {
                        if (!validationMessage.includes(message)) {
                            validationMessage.push(message);
                        }
                    });

                    validationElement.innerHTML = validationMessage.join('<br>');
                    addToQuoteButton.classList.remove('loading');
                });
        });
    }
});
